Imports System.IO

Public Class Form1
    Private Sub mnuFileOpen_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuFileOpen.Click
        If ofdOriginal.ShowDialog() = Windows.Forms.DialogResult.OK Then
            Try
                ' Load the original image.
                picOriginal.Image = LoadImage(ofdOriginal.FileName)
                picNew.Image = Nothing
                txtCompressionLevel.Clear()

                ' Display the file's size.
                Dim file_info As New FileInfo(ofdOriginal.FileName)
                txtOriginalSize.Text = FormatBytes(file_info.Length)
                txtDesiredSize.Text = FormatBytes(file_info.Length * 0.5)
                txtCompressedSize.Clear()
                txtCompressionLevel.Clear()
            Catch ex As Exception
                MessageBox.Show("Error loading picture file " & _
                    ofdOriginal.FileName & vbCrLf & ex.Message, _
                    "File Load Error", _
                    MessageBoxButtons.OK, _
                    MessageBoxIcon.Error)
            End Try
        End If
    End Sub

    Private Sub mnuFileSaveAs_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuFileSaveAs.Click
        Try
            Dim desired_size As Double = FormattedBytesToBytes(txtDesiredSize.Text)
            If desired_size < 10 Then
                MessageBox.Show("Invalid desired size.", _
                    "Invalid Size", MessageBoxButtons.OK, _
                    MessageBoxIcon.Error)
                txtDesiredSize.Focus()
                Exit Sub
            End If

            If sfdJpeg.ShowDialog() = Windows.Forms.DialogResult.OK Then
                picNew.Image = Nothing
                txtCompressionLevel.Clear()
                txtCompressedSize.Clear()

                Dim file_name As String = sfdJpeg.FileName
                Dim file_size As Long
                For compression_level As Integer = 100 To 10 Step -1
                    ' Save the file into a memory stream.
                    Dim memory_stream As MemoryStream = SaveJpegIntoStream(picOriginal.Image, compression_level)

                    ' See how big it is.
                    file_size = memory_stream.Length
                    If file_size <= desired_size Then
                        ' Display the final size and image.
                        ' Save the file.
                        My.Computer.FileSystem.WriteAllBytes(file_name, memory_stream.ToArray(), False)
                        picNew.Image = LoadImage(file_name)
                        txtCompressionLevel.Text = compression_level
                        txtCompressedSize.Text = FormatBytes(file_size)
                        Exit For
                    End If
                Next compression_level
            End If
        Catch ex As Exception
            MessageBox.Show("Error saving file." & _
                vbCrLf & ex.Message, "Save Error", _
                MessageBoxButtons.OK, MessageBoxIcon.Error)
        End Try
    End Sub

    ' Load a bitmap so it's not locked.
    Private Function LoadImage(ByVal file_name As String) As Bitmap
        Using bm As New Bitmap(file_name)
            Dim bm2 As New Bitmap(bm)
            Return bm2
        End Using
    End Function
End Class
